"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _Observable = _interopRequireDefault(require("./Observable"));

var data = (0, _Observable.default)({
  idx: 1,
  name: "test",
  info: {
    age: 18
  }
}, {
  fullName: function fullName() {
    return this.name + this.info.age;
  }
}); // data.$watch("info.age", (a, b) => console.log("age changed:", a));
// data.$watch("name", (a, b) => console.log("name changed:", a));

data.$watch(function () {
  console.log("trigger c");

  if (this.idx % 3) {
    return this.name;
  } else {
    return this.info.age;
  }
}, function (a, b) {
  return console.log("trigger changed:", a);
});
data.$watch("fullName", function (a, b) {
  return console.log("fullName changed:", a);
});
console.log(data.fullName, "fullName");
data.name = "hello";
data.info.age = 20;
data.info.age = 21;
data.info.age = 22;
data.idx = 3;
data.name = "hello2";
data.idx = 6;
data.name = "vvvs";